#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n, q; cin>>n>>q;
    long long pa = 0;

    vector<long long> v(n);

    for(int i=0; i<n; i++){
        long long d, p; cin>>d>>p;
        if(i==0){
            v[i]=max(d, p);
            continue;
        }
        if(d>0){
            v[i]=d+v[i-1];
        }
        else{
            pa+=p;
            v[i]=pa+v[i-1];
        }
    }

    for(int i=0; i<q; i++){
        long long a; cin>>a;
        int y = lower_bound(v.begin(), v.end(), a)-v.begin();
        if(y!=n){
            cout<<y+1<<endl;
        }
        else{
            cout<<-1<<endl;
        }
    }

    return 0;
}